
"""
.. module:: FD_exercises.py
    :synopsis: It contains exercises of "Atmospheric Numerical Modeling" book
     that have served to test the finite diference BVE model.
.. moduleauthor:: Kereman Alonso (alonso.kerman5@gmail.com)
"""

import math
import numpy as np
from numpy import float64
import matplotlib
from matplotlib import pyplot as plt

import FD_operators_equations as operators_equations


if __name__ == "__main__":

    """
    Ex. 7.1
    """
    # #  a
    # A = -5e6
    # B = 7.4e8
    # C = 8e7
    # D = -1.5e8
    # k = math.pi / 25
    # sigma = 10.0
    # nx = 101
    # ny = 51
    # d = 200000.0
    
    # streamfunction = np.zeros((ny, nx), dtype=float64)
    # for i in range(ny):
    #     for j in range(nx):
    #         i_prima = j
    #         j_prima = - i + (ny - 1)
    #         r = math.sqrt((i_prima - 55.0) ** 2 + (j_prima - 20.0) ** 2)
    #         streamfunction[i, j] = A * j_prima + B + C * math.cos(k * i_prima)\
    #             + D * math.exp(- (r ** 2) / (2 * sigma ** 2))
          
    # x = np.zeros(nx, dtype=float64)
    # for i in range(len(x)):
    #     x[i] = 1 * i

    # y = np.zeros(ny, dtype=float64)
    # for i in range(len(y)):
    #     y[i] = 1 * (- i + (ny - 1))

    # plt.figure(1)
    # plt.contour(x, y, streamfunction, levels=10, colors='black')
    # # print("streamfunction: ", streamfunction[-20 +
    # #                                           streamfunction.shape[0]-1, 30])

    # #  b
    # laplacian = np.zeros((ny, nx), dtype=float64)
    
    # # Measure average laplacian execution time
    # # Call function one time to just in time compile it
    # laplacian = operators_equations.laplacian_5(streamfunction, d,
    #                                               boundary='fixed',
    #                                               old_laplacian=laplacian)
    # iteration_number = 10
    # start_time = time.time()
    # for i in range(iteration_number):
    #     laplacian = operators_equations.laplacian_5(streamfunction, d,
    #                                               boundary='fixed',
    #                                               old_laplacian=laplacian)
    # print("laplacian execution time, %s iterations" % (iteration_number))
    # print("--- %s seconds ---" % (time.time() - start_time))
    # # Plot laplacian
    # plt.figure(2)
    # plt.contour(x, y, laplacian, levels=10, colors='black')
    # # print("laplacian: ", laplacian[-20+laplacian.shape[0]-1, 30])

    """
    Ex. 7.2 (uses 7.1)
    """
    # jacobian = np.zeros((ny, nx), dtype=float64)

    # # Measure average jacobian execution time
    # # Call function one time to just in time compile it
    # jacobian = operators_equations.jacobian(streamfunction, laplacian, d,
    #                                             boundary='fixed',
    #                                             old_jacobian=jacobian)
    
    # iteration_number = 10
    # start_time = time.time()
    # for i in range(iteration_number):
    #     jacobian = operators_equations.jacobian(streamfunction, laplacian, d,
    #                                             boundary='fixed',
    #                                             old_jacobian=jacobian)
    # print("jacobian execution time, %s iterations" % (iteration_number))
    # print("--- %s seconds ---" % (time.time() - start_time))

    # # Plot jacobian
    # plt.figure(3)
    # plt.contour(x, y, jacobian, levels=10, colors='black')
    # # print("jacobian: ", jacobian[-20+jacobian.shape[0]-1, 30])
     
    """
    Ex. 7.3
    """  
    # # a
    # A1 = 7.0e-5
    # A2 = 4.9e-5
    # sigma1 = 5.0
    # sigma2 = 7.5
    # nx = 101
    # ny = 51
    # d = 200000.0
    
    # zeta = np.zeros((ny, nx), dtype=float64)
    # for i in range(ny):
    #     for j in range(nx):
    #         i_prima = j
    #         j_prima = - i + (ny - 1) 
    #         r1 = math.sqrt((i_prima - 65.0) ** 2 + (j_prima - 30.0) ** 2)
    #         r2 = math.sqrt((i_prima - 30.0) ** 2 + (j_prima - 20.0) ** 2)
    #         zeta[i, j] = A1 * math.exp(- (r1 ** 2) / (2 * sigma1 ** 2)) -\
    #             A2 * math.exp(- (r2 ** 2) / (2 * sigma2 ** 2))

    # x = np.zeros(nx, dtype=float64)
    # for i in range(len(x)):
    #     x[i] = 1 * i

    # y = np.zeros(ny, dtype=float64)
    # for i in range(len(y)):
    #     y[i] = 1 * (- i + (ny - 1))

    # plt.figure(4)
    # plt.contour(x, y, zeta, levels=10, colors='black')
    # #print("zeta: ", zeta[-20+zeta.shape[0]-1, 30])

    # # b    
    # old_psi = np.zeros((ny, nx), dtype=float64)
    # threshold = 1.0e-7
    # # Measure average poisson_matrix execution time
    # # Call function one time to just in time compile it
    # psi = operators_equations.poisson_relaxation(zeta, d, 
    #                                                   threshold, 
    #                                                   'fixed',
    #                                                   old_psi)
    # # psi = operators_equations.poisson_matrix(zeta, d, boundary='fixed',
    # #                                         old_psi=old_psi)
    
    # iteration_number = 10
    # start_time = time.time()
    # for i in range(iteration_number):
    #     psi = operators_equations.poisson_relaxation(zeta, d, 
    #                                                  threshold,
    #                                                  'fixed',
    #                                                  old_psi,)
    #     # psi = operators_equations.poisson_matrix(zeta, d, boundary='fixed',
    #     #                                    old_psi=old_psi)
    # print("poisson_relaxation execution time, %s iterations" %
    #       (iteration_number))
    # print("--- %s seconds ---" % (time.time() - start_time))

    # # Plot zeta
    # plt.figure(5)
    # plt.contour(x, y, psi, levels=10, colors='black')
    # # print("psi_b: ", psi[-20+psi.shape[0]-1, 30])
    
    # # zeta_new = operators_equations.laplacian_5(psi, d, boundary='fixed',
    # #                                           old_laplacian=zeta)
    
    # # plt.figure(6)
    # # plt.contour(x, y, zeta_new, levels=10, colors='black')
    # # # print("zeta: ", zeta_new[-20+zeta_new.shape[0]-1, 30])
    
    # # c
    # psi = np.zeros((ny, nx), dtype=float64)
    # a = -5.0e6
    # b = 7.4e8
    # for i in range(ny):
    #     for j in range(nx):
    #         i_prima = j
    #         j_prima = - i + (ny - 1)
    #         psi[i, j] = a * j_prima + b
    # plt.figure(7)
    # matplotlib.pyplot.contour(x, y, psi, levels=10, colors='black')

    # psi = operators_equations.poisson_relaxation(zeta, d, 1.0e-7, 'fixed', psi)
    # # psi = operators_equations.poisson_matrix(zeta, d, boundary='fixed',
    # #                                           old_psi=psi)

    # plt.figure(8)
    # matplotlib.pyplot.contour(x, y, psi, levels=10, colors='black')
    # # print("psi_c2: ", psi[-20+psi.shape[0]-1, 30])
    
    """
    Ex. 7.4
    """
    # a
    A = -5.0e6
    B = 7.4e8
    C = -6.0e7
    D = 5.0e7
    sigma1 = 3.5
    sigma2 = 6.0
    nx = 101
    ny = 51
    d = 200000.0
    
    psi = np.zeros((ny, nx), dtype=float64)
    for i in range(ny):
        for j in range(nx):
            i_prima = j
            j_prima = - i + (ny - 1)
            r1 = math.sqrt((i_prima - 25.0) ** 2 + (j_prima - 20.0) ** 2)
            r2 = math.sqrt((i_prima - 35.0) ** 2 + (j_prima - 30.0) ** 2)
            psi[i, j] = A * j_prima + B + C *\
                math.exp(- (r1 ** 2) / (2 * sigma1 ** 2))\
                + D * math.exp(- (r2 ** 2) / (2 * sigma2 ** 2))
        
    x = np.zeros(nx, dtype=float64)
    for i in range(len(x)):
        x[i] = 1 * i

    y = np.zeros(ny, dtype=float64)
    for i in range(len(y)):
        y[i] = 1 * (- i + (ny - 1))

    plt.figure(1)
    matplotlib.pyplot.contour(x, y, psi, levels=10, colors='black')
    
    # b
    dt = 900.0
    threshold = 1.0e-7
    # Calculate beta
    omega = 7.2921e-5  # angular velocity of Earth
    a = 6.3781e6  # radius of Earth
    f = np.zeros((ny, nx), dtype=float64)
    for i in range(ny):
        for j in range(nx):
            sin_psi = d * (- i + ny // 2) / a
            f[i, j] = 2 * omega * sin_psi
    beta = np.zeros((ny, nx), dtype=float64)
    beta = operators_equations.\
        centered_partial_horizontal(f, d,
                                    boundary='mixed',
                                        old_derivative=beta)
    
    # Calculate initial vorticity (zeta)
    zeta_boundary = np.zeros((ny, nx), dtype=float64)
    old_zeta = operators_equations.laplacian_5(psi, d, boundary='fixed',
                                          old_laplacian=zeta_boundary)
    zeta = np.zeros((ny, nx), dtype=float64)
    future_zeta = np.zeros((ny, nx), dtype=float64)
    
    # Calculate initial J and vg
    J_boundary = np.zeros((ny, nx), dtype=float64)
    vg_boundary = np.zeros((ny, nx), dtype=float64)
    
    J = operators_equations.jacobian(psi, old_zeta, d, boundary='fixed',
                                      old_jacobian=J_boundary)
    
    vg = operators_equations.\
        centered_partial_horizontal(psi, d,
                                    boundary='fixed',
                                        old_derivative=vg_boundary)
    # Calculate new vorticity (zeta) using forward scheme
    for i in range(ny):
        for j in range(nx):
            zeta[i, j] = old_zeta[i, j] -\
                dt * (J[i, j] + beta[i, j] * vg[i, j])

    # Calculate new streamfunction (psi)
    psi = operators_equations.poisson_relaxation(zeta, d, threshold,
                                                     'fixed', psi)

    for t in range(2, int(3600 * 72/ 900) + 1):
        # Calculate J and vg
        J = operators_equations.jacobian(psi, zeta, d, boundary='fixed',
                                          old_jacobian=J_boundary)
        
        vg = operators_equations.\
            centered_partial_horizontal(psi, d,
                                        boundary='fixed',
                                        old_derivative=vg_boundary)
        
        # Calculate new vorticity (zeta) using centered scheme
        for i in range(ny):
            for j in range(nx):
                future_zeta[i, j] = old_zeta[i, j] -\
                    2 * dt * (J[i, j] + beta[i, j] * vg[i, j])
        
        # Swap vorticity (zeta) variables
        old_zeta[:] = zeta[:]
        zeta[:] = future_zeta[:]
        
        # Calculate new streamfunction (psi)
        psi = operators_equations.poisson_relaxation(zeta, d, threshold,
                                                     'fixed', psi)
        if (t * 900 / 3600 % 6 == 0):
            plt.figure(t+1)
            plt.contour(x, y, psi, levels=10, colors='black')
        
