
"""
.. module:: get_ERA_Interim_data.py
    :synopsis: It contains the code used to download the ERA Interim analysis
    and forecasts data.
.. moduleauthor:: Kereman Alonso (alonso.kerman5@gmail.com)
"""

from ecmwfapi import ECMWFDataServer
server = ECMWFDataServer()

"""
Get analysis
"""

# # 2018-12

# server.retrieve({
#     "class": "ei",
#     "dataset": "interim",
#     "date": "2018-12-01/to/2018-12-31",
#     "expver": "1",
#     "grid": "0.75/0.75",
#     "levelist": "200/300/500/700",
#     "levtype": "pl",
#     "param": "131.128/132.128/135.128/138.128",
#     "step": "0",
#     "stream": "oper",
#     "time": "00:00:00/06:00:00/12:00:00/18:00:00",
#     "type": "an",
#     "format": "netcdf",
#     "target": "..\\..\\data\\an_2018_12.nc",
# })

# # 2019-01

# server.retrieve({
#     "class": "ei",
#     "dataset": "interim",
#     "date": "2019-01-01/to/2019-01-31",
#     "expver": "1",
#     "grid": "0.75/0.75",
#     "levelist": "200/300/500/700",
#     "levtype": "pl",
#     "param": "131.128/132.128/135.128/138.128",
#     "step": "0",
#     "stream": "oper",
#     "time": "00:00:00/06:00:00/12:00:00/18:00:00",
#     "type": "an",
#     "format": "netcdf",
#     "target": "..\\..\\data\\an_2019_01.nc",
# })

# # 2019-07

# server.retrieve({
#     "class": "ei",
#     "dataset": "interim",
#     "date": "2019-07-01/to/2019-07-31",
#     "expver": "1",
#     "grid": "0.75/0.75",
#     "levelist": "200/300/500/700",
#     "levtype": "pl",
#     "param": "131.128/132.128/135.128/138.128",
#     "step": "0",
#     "stream": "oper",
#     "time": "00:00:00/06:00:00/12:00:00/18:00:00",
#     "type": "an",
#     "format": "netcdf",
#     "target": "..\\..\\data\\an_2019_07.nc",
# })

# # 2019-08

# server.retrieve({
#     "class": "ei",
#     "dataset": "interim",
#     "date": "2019-08-01/to/2019-08-31",
#     "expver": "1",
#     "grid": "0.75/0.75",
#     "levelist": "200/300/500/700",
#     "levtype": "pl",
#     "param": "131.128/132.128/135.128/138.128",
#     "step": "0",
#     "stream": "oper",
#     "time": "00:00:00/06:00:00/12:00:00/18:00:00",
#     "type": "an",
#     "format": "netcdf",
#     "target": "..\\..\\data\\an_2019_08.nc",
# })

"""
Get forecasts
"""

# 2018-12

# server.retrieve({
#     "class": "ei",
#     "dataset": "interim",
#     "date": "20181201/20181210/20181220",
#     "expver": "1",
#     "grid": "0.75/0.75",
#     "levelist": "200/300/500/700",
#     "levtype": "pl",
#     "param": "131.128/132.128/135.128/138.128",
#     "step": "6/12/18/24/30/36/42/48",
#     "stream": "oper",
#     "time": "00:00:00",
#     "type": "fc",
#     "format": "netcdf",
#     "target": "..\\..\\data\\fc_2018_12.nc",
# })

# 2019-01

# server.retrieve({
#     "class": "ei",
#     "dataset": "interim",
#     "date": "20190101/20190110/20190120",
#     "expver": "1",
#     "grid": "0.75/0.75",
#     "levelist": "200/300/500/700",
#     "levtype": "pl",
#     "param": "131.128/132.128/135.128/138.128",
#     "step": "6/12/18/24/30/36/42/48",
#     "stream": "oper",
#     "time": "00:00:00",
#     "type": "fc",
#     "format": "netcdf",
#     "target": "..\\..\\data\\fc_2019_01.nc",
# })

# 2019-07

# server.retrieve({
#     "class": "ei",
#     "dataset": "interim",
#     "date": "20190701/20190710/20190720",
#     "expver": "1",
#     "grid": "0.75/0.75",
#     "levelist": "200/300/500/700",
#     "levtype": "pl",
#     "param": "131.128/132.128/135.128/138.128",
#     "step": "6/12/18/24/30/36/42/48",
#     "stream": "oper",
#     "time": "00:00:00",
#     "type": "fc",
#     "format": "netcdf",
#     "target": "..\\..\\data\\fc_2019_07.nc",
# })

# 2019-08

# server.retrieve({
#     "class": "ei",
#     "dataset": "interim",
#     "date": "20190801/20190810/20190820",
#     "expver": "1",
#     "grid": "0.75/0.75",
#     "levelist": "200/300/500/700",
#     "levtype": "pl",
#     "param": "131.128/132.128/135.128/138.128",
#     "step": "6/12/18/24/30/36/42/48",
#     "stream": "oper",
#     "time": "00:00:00",
#     "type": "fc",
#     "format": "netcdf",
#     "target": "..\\..\\data\\fc_2019_08.nc",
# })

# 2019-07 7h forecasts

server.retrieve({
    "class": "ei",
    "dataset": "interim",
    "date": "20190701/20190710/20190720",
    "expver": "1",
    "grid": "0.75/0.75",
    "levelist": "200/300/500/700",
    "levtype": "pl",
    "param": "131.128/132.128/135.128/138.128",
    "step": "12/24/36/48/60/72/84/96/108/120/132/144/156/168",
    "stream": "oper",
    "time": "00:00:00",
    "type": "fc",
    "format": "netcdf",
    "target": "..\\..\\data\\ACC_fc_2019_07.nc",
})
